#!/bin/bash

# traffic_per_second.sh <packet log file name>

# determine packet traffic per second statistics from tcpdump packet log in -v format

log=${1:-packet.log}

foo=traffic_per_second.sh.$$.1

# make a file with <time> <length> on each line
awk '{print $1, $NF}' < $log \
 | tr -d ')' \
 | tr ':' ' ' \
 | awk '{print $1*3600 + $2*60 + $3, $4}' - > $foo

# compute statistics
tot_bits=`cat $foo | total | awk '{print $1*8}' -`
start_time=`head -n 1 $foo | first`
stop_time=`tail -n 1 $foo | first`
time_interval=`echo $stop_time $start_time | awk '{print $1 - $2}' -`
avg_bits_per_sec=`echo $tot_bits $time_interval | awk '{print $1/$2}' -`

rm $foo

# echo Start time: $start_time
# echo Stop time: $stop_time
echo Time interval: $time_interval sec.
echo Average: $avg_bits_per_sec bits per sec.

